package cn.newfeifan.mall.module.pay.controller.app.fuyouorder;

import cn.newfeifan.mall.framework.common.exception.ErrorCode;
import cn.newfeifan.mall.framework.common.pojo.CommonResult;
import cn.newfeifan.mall.module.pay.fuiou.reqvo.SubmitOrderRequestVO;
import cn.newfeifan.mall.module.pay.fuiou.respVO.FuYouPaymentResponseVO;
import cn.newfeifan.mall.module.pay.fuiou.util.FuiouHttpPoster;
import cn.newfeifan.mall.module.pay.fuiou.util.MD5;
import cn.newfeifan.mall.module.pay.fuiou.util.Test;
import cn.newfeifan.mall.module.pay.service.fuyouorder.FuYouPayOrderService;
import com.alibaba.fastjson.JSON;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.httpclient.HttpClient;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

import static cn.newfeifan.mall.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.newfeifan.mall.framework.common.pojo.CommonResult.success;

@Tag(name = "用户 APP - 富有支付订单")
@RestController
@RequestMapping("/fuYou/pay/order")
@Validated
@Slf4j
public class NewPayOrderController {

    @Resource
    private FuYouPayOrderService fuYouPayOrderService;

    @PostMapping("/submit")
    @Operation(summary = "向富友提交支付订单")
    public CommonResult<String> submitFuYouPayOrder(@RequestBody SubmitOrderRequestVO reqVO) {

        try{
        String respVO = fuYouPayOrderService.submitOrder(reqVO);

        }catch (Exception e){
            ErrorCode err = new ErrorCode(1,e.getMessage() + "===1");
            throw exception(err);
        }


        return success("success");
    }

    @PostMapping("/test1")
    @Operation(summary = "test1")
    public CommonResult<String> test1() {
        FuiouHttpPoster http = new FuiouHttpPoster();
        http.setUrl("//");
        return success("success");
    }
    @PostMapping("/test2")
    @Operation(summary = "test2")
    public CommonResult<String> test2() {
        HttpClient httpclient = new HttpClient();
        return success("success");
    }
    @PostMapping("/test3")
    @Operation(summary = "test3")
    public CommonResult<String> test3() {
        FuiouHttpPoster http = new FuiouHttpPoster();
        http.setUrl("//");
        try {
            String res = http.newPost(JSON.toJSONString(""));
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        return success("success");
    }
    @PostMapping("/test4")
    @Operation(summary = "test4")
    public CommonResult<String> test4() {
        Test http = new Test();
        http.setUrl("//");
//        try {
//            String res = http.newPost(JSON.toJSONString(""));
//        } catch (Exception e) {
//            throw new RuntimeException(e);
//        }
        return success("success");
    }

    @PostMapping("/notify")
    @Operation(summary = "富友支付订单回调")
    public CommonResult<String> notifyFuYouPayOrder(@RequestBody FuYouPaymentResponseVO responseVO) {


        System.out.println(responseVO.toString());
//        fiYouPayOrderService.notifyOrder(notify);

        return success("success");
    }

    @PostMapping("/afterSale")
    @Operation(summary = "向富友申请退款")
    public CommonResult<String> afterSaleFuYouPayOrder(Long afterSaleId) {

        fuYouPayOrderService.afterSale(afterSaleId);

        return success("success");
    }
}
